/*
 * The functions in this file negotiate with the operating system for
 * characters, and write characters buffered on the display.
 * Only ABC1600, replaces termio.c
 */

#include	<signal.h>
#include	<termio.h>
#include	<sys/ioctl.h>
#include        <stdio.h>
#include	"estruct.h"
#include        "edef.h"

#define	NOBUF	256		/* you may want to fiddle with this size */

char obuf[NOBUF];		/* output buffer */
int nobuf;			/* # of bytes in above */

struct	termio	otermio;	/* original terminal characteristics */
struct	termio	ntermio;	/* charactoristics to use inside */

/*
 * This function is called once to set up the terminal device streams.
 */

ttopen ()
{
	ioctl ( 0, TCGETA, &otermio );	/* save old settings */
	ntermio.c_iflag = 0;		/* setup new settings */
	ntermio.c_oflag = 0;
	ntermio.c_cflag = otermio.c_cflag;
	ntermio.c_lflag = 0;
	ntermio.c_line  = otermio.c_line;
	ntermio.c_cc[VMIN] = 1;
	ntermio.c_cc[VTIME] = 0;
	ioctl ( 0, TCSETA, &ntermio );	/* and activate them */

	/*
	 * on all screens we are not sure of the initial position
	 *  of the cursor
	 */

	ttrow = 999;
	ttcol = 999;
}

/*
 * This function gets called just before we go back home to the command
 * interpreter.
 */

ttclose ()
{
	ioctl ( 0, TCSETA, &otermio );	/* restore terminal settings */
}

/*
 * Write a character to the display.
 */

ttputc ( c )
int c;

{
	if ( nobuf >= NOBUF ) {
		ttflush ();
	}
	obuf[nobuf++] = c;
}

/*
 * Flush terminal buffer.
 */

ttflush()
{
	if ( nobuf ) {
		write ( 1, obuf, nobuf );
		nobuf = 0;
	}
}

/*
 * Read a character from the terminal, performing no editing and doing no echo
 * at all.
 */

ttgetc()
{
        return ( 0x7F & fgetc ( stdin ) );
}

#if	TYPEAH

/* typahead:
 *	Check to see if any characters are already in the keyboard buffer
 */

typahead()
{
	return ( rdchk ( 0 ) ? TRUE : FALSE );
}

#endif
